package cz.nic.tablexia.bus;

import net.engio.mbassy.bus.MBassador;
import net.engio.mbassy.bus.config.BusConfiguration;
import net.engio.mbassy.bus.config.Feature;
import net.engio.mbassy.bus.config.IBusConfiguration;
import cz.nic.tablexia.bus.ApplicationBus.ApplicationEvent;

public class ApplicationBus extends MBassador<ApplicationEvent> {
	
	public interface ApplicationEvent {};
	
	private static ApplicationBus instance;
	
	private ApplicationBus(IBusConfiguration configuration) {
		super(configuration);
	}
	
	public static ApplicationBus getInstance() {
		if (instance == null) {
			IBusConfiguration defaultConfig = new BusConfiguration();
	        defaultConfig.addFeature(Feature.SyncPubSub.Default());
	        defaultConfig.addFeature(Feature.AsynchronousHandlerInvocation.Default());
	        defaultConfig.addFeature(Feature.AsynchronousMessageDispatch.Default());
			instance = new ApplicationBus(defaultConfig);
		}
		return instance;
	}

}
