package cz.nic.tablexia.bus.event;

import cz.nic.tablexia.bus.ApplicationBus;
import cz.nic.tablexia.menu.AbstractMenu;

public class MenuControlEvent implements ApplicationBus.ApplicationEvent {

    private Class<? extends AbstractMenu>   menu;
    private AbstractMenu.MenuAction         menuAction;
    private boolean                         animated;

    public MenuControlEvent(Class<? extends AbstractMenu> menu, AbstractMenu.MenuAction menuAction, boolean animated) {
        this.menu = menu;
        this.menuAction = menuAction;
        this.animated = animated;
    }

    public Class<? extends AbstractMenu> getMenu() {
        return menu;
    }

    public AbstractMenu.MenuAction getMenuAction() {
        return menuAction;
    }

    public boolean isAnimated() {
        return animated;
    }
}
