package cz.nic.tablexia.bus.event;

import cz.nic.tablexia.bus.ApplicationBus;
import cz.nic.tablexia.menu.AbstractMenu;
import cz.nic.tablexia.menu.IMenuItem;

public class SubMenuControlEvent implements ApplicationBus.ApplicationEvent {

    public enum SubMenuAction {
        OPEN    (false),
        CLOSE   (true),
        TOGGLE  (null);

        private Boolean isOpen;

        SubMenuAction(Boolean isOpen) {
            this.isOpen = isOpen;
        }

        public boolean isOpen(boolean isMenuOpenNow) {
            return isOpen != null ? isOpen : !isMenuOpenNow;
        }
    }

    private Class<? extends AbstractMenu>   menu;
    private IMenuItem                       menuItem;
    private SubMenuAction subMenuAction;

    public SubMenuControlEvent(Class<? extends AbstractMenu> menu, IMenuItem menuItem, SubMenuAction subMenuAction) {
        this.menu           = menu;
        this.menuItem       = menuItem;
        this.subMenuAction = subMenuAction;
    }

    public Class<? extends AbstractMenu> getMenu() {
        return menu;
    }

    public IMenuItem getMenuItem() {
        return menuItem;
    }

    public SubMenuAction getSubMenuAction() {
        return subMenuAction;
    }
}
