package cz.nic.tablexia.debug;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Stage;

/**
 * Created by frantisek on 10.12.15.
 */
public class DebugActor extends Actor {

    private ShapeRenderer renderer;

    public DebugActor() {
        this.renderer = new ShapeRenderer();
    }

    @Override
    protected void setStage(Stage stage)
    {
        super.setStage(stage);
        if (stage != null) {
            renderer.setProjectionMatrix(getStage().getCamera().combined);
        }
    }

    public void draw(Batch batch, float parentAlpha) {
        batch.end();

        renderer.setAutoShapeType(true);
        renderer.begin();
        renderer.set(ShapeRenderer.ShapeType.Line);
        renderer.setColor(Color.RED);
        renderer.rect(getX(), getY(), getWidth(), getHeight());
        renderer.end();

        batch.begin();
    }
}
