package cz.nic.tablexia.game.games.in_the_darkness.action.rule;

import com.badlogic.gdx.scenes.scene2d.Actor;

import cz.nic.tablexia.game.games.in_the_darkness.InTheDarknessGame;
import cz.nic.tablexia.game.games.in_the_darkness.action.ActionType.IActionFinishedListener;
import cz.nic.tablexia.game.games.in_the_darkness.creature.Player;
import cz.nic.tablexia.game.games.in_the_darkness.map.TileMap;

import static com.badlogic.gdx.scenes.scene2d.actions.Actions.delay;
import static com.badlogic.gdx.scenes.scene2d.actions.Actions.run;

/**
 * Abstract action type rule
 * 
 * @author Matyáš Latner
 */
public abstract class AbstractActionTypeRule {

	public abstract void performActionRule(InTheDarknessGame inTheDarknessGame, TileMap tileMap, Player player, int mapStartPositionX, int mapStartPositionY, IActionFinishedListener actionFinishedListener);
	
	protected void performOnActionFinished(IActionFinishedListener finishedListener, boolean result) {			
		if (finishedListener != null) {
			finishedListener.onActionFinished(result);
		}
	}
	
	protected void performOnActionFinishWithDelay(Actor actor, final IActionFinishedListener finishedListener, final boolean result, final int delay) {
		actor.addAction(delay(delay, run(new Runnable() {
			@Override
			public void run() {
				performOnActionFinished(finishedListener, result);
			}
		})));
    }
}
