package cz.nic.tablexia.game.games.kidnapping.actions;

import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.DelegateAction;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;

import cz.nic.tablexia.game.games.kidnapping.actions.fades.BlinkAction;
import cz.nic.tablexia.game.games.kidnapping.actors.Arrow;

/**
 * Created by lhoracek on 5/22/15.
 */
public class ArrowMusicAction extends DelegateAction {


    public ArrowMusicAction(Arrow arrow, Music music) {
        setAction(new WhileAction(Actions.sequence(Actions.delay(1f), PlayMusicAction.getInstance(music), Actions.delay(1f)), new BlinkAction(arrow)));
    }

    @Override
    protected boolean delegate(float delta) {
        return getAction().act(delta);
    }

    public static Action arrowSequence(Music[] sounds, Arrow[] arrows){
        SequenceAction sa = Actions.sequence();
        for(int i = 0; i< sounds.length; i++){
            sa.addAction(new ArrowMusicAction(arrows[i], sounds[i]));
        }
        return sa;
    }
}
