package cz.nic.tablexia.game.games.kidnapping.actions;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.MoveToAction;

import cz.nic.tablexia.game.games.kidnapping.actors.Map;
import cz.nic.tablexia.game.games.kidnapping.actors.Tile;

/**
 * Created by lhoracek on 5/20/15.
 */
public class CenterTileAction extends MoveToAction {
    private Tile tile;

    public Tile getTile() {
        return tile;
    }

    public void setTile(Tile tile) {
        this.tile = tile;
    }

    @Override
    public void setActor(Actor actor) {
        super.setActor(actor);
        if (actor != null) {
            if (!(actor instanceof Map)) {
                throw new IllegalArgumentException("Needs Tile actor instead " + actor.getClass().getName());
            }
            Map map = (Map) actor;
            float x = -tile.getCenterX() * map.getMapScale() + map.getWidth() / 2;
            float y = -tile.getCenterY() * map.getMapScale() + map.getHeight() / 2;
            setPosition(x, y);
            setTarget(map.getTiles());
        }
    }

    public static CenterTileAction getInstance(Tile tile) {
     return getInstance(tile, 0);
    }

    public static CenterTileAction getInstance(Tile tile, float duration) {
        CenterTileAction action = Actions.action(CenterTileAction.class);
        action.setDuration(duration);
        action.setTile(tile);
        return action;
    }
}
