package cz.nic.tablexia.game.games.kidnapping.actions;

import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.utils.Pool;

/**
 * Created by lhoracek on 5/20/15.
 */
public class PlayMusicAction extends Action {
    private boolean finished = false;
	private boolean played = false;
    private Music music;

    @Override
    public void reset() {
        super.reset();
        finished = false;
    }

    @Override
    public void restart() {
        super.restart();
        finished = false;
    }

    public Music getMusic() {
        return music;
    }

    public void setMusic(Music music) {
        this.music = music;
        this.music.setOnCompletionListener(new Music.OnCompletionListener() {
            @Override
            public void onCompletion(Music music) {
                finished = true;
				played = false;
            }
        });
    }

    @Override
    public boolean act(float delta) {
        Pool pool = getPool();
        setPool(null); // Ensure this action can't be returned to the pool while executing.
        if (!finished && !music.isPlaying() && !played) {
			music.play();
			played = true;
        }
        setPool(pool);
        return finished;
    }

    public static PlayMusicAction getInstance(Music music) {
        final PlayMusicAction action = Actions.action(PlayMusicAction.class);
        action.setMusic(music);
        return action;
    }
}
