package cz.nic.tablexia.game.games.kidnapping.actions;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.ParallelAction;

/**
 * Created by lhoracek on 5/20/15.
 */
public class WhileAction extends ParallelAction {
    final Action whileAction, repeatAction;

    public WhileAction(Action whileAction, Action repeatAction) {
        super(whileAction, repeatAction);
        this.whileAction = whileAction;
        this.repeatAction = repeatAction;
    }

    @Override
    public boolean act(float delta) {
        boolean running = !whileAction.act(delta);
        boolean restart = repeatAction.act(delta);
        if (running && restart) {
            repeatAction.restart();
        }
        return !running && restart;
    }
}
