package cz.nic.tablexia.game.games.kidnapping.actions.fades;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.ParallelAction;

import cz.nic.tablexia.game.games.kidnapping.actors.Arrow;
import cz.nic.tablexia.game.games.kidnapping.actors.Map;

/**
 * Created by lhoracek on 5/25/15.
 */
public class ShowArrowAction extends SubActorFadeAction<Map> {
    private Arrow arrow;

    public Arrow getArrow() {
        return arrow;
    }

    public void setArrow(Arrow arrow) {
        this.arrow = arrow;
    }

    @Override
    public Actor getTargetActor(Map map) {
        return arrow;
    }

    public static ShowArrowAction fadeIn(Arrow arrow) {
        ShowArrowAction sfa = getFade(ShowArrowAction.class, DEFAULT_DURATION, 1);
        sfa.setArrow(arrow);
        return sfa;
    }

    public static ShowArrowAction fadeOut(Arrow arrow) {
        ShowArrowAction sfa = getFade(ShowArrowAction.class, DEFAULT_DURATION, 0);
        sfa.setArrow(arrow);
        return sfa;
    }

    public static Action arrowsFadeIn(Arrow[] arrows) {
        ParallelAction pa = Actions.parallel();
        for (Arrow a : arrows) {
            pa.addAction(ShowArrowAction.fadeIn(a));
        }
        return pa;
    }

    public static Action arrowsFadeOut(Arrow[] arrows) {
        ParallelAction pa = Actions.parallel();
        for (Arrow a : arrows) {
            pa.addAction(ShowArrowAction.fadeOut(a));
        }
        return pa;
    }
}
