package cz.nic.tablexia.game.games.kidnapping.actions.fades;

import com.badlogic.gdx.scenes.scene2d.Actor;

import cz.nic.tablexia.game.games.kidnapping.actors.Map;
import cz.nic.tablexia.game.games.kidnapping.actors.Tile;
import cz.nic.tablexia.game.games.kidnapping.model.Direction;
import cz.nic.tablexia.game.games.kidnapping.model.Position;

/**
 * Created by lhoracek on 5/19/15.
 */
public class ShowRoadAction extends ShowFlagAction {

    Direction direction;

    public Direction getDirection() {
        return direction;
    }

    public void setDirection(Direction direction) {
        this.direction = direction;
    }

    @Override
    public Actor getTargetActor(Map map) {
        Tile tile = map.getTile(getPosition());
        Actor road = direction == Direction.NE ? tile.getPathNorthEast() : tile.getPathNorthWest();
        return road;
    }


    public static ShowRoadAction fadeIn(Position position, Direction direction) {
        if (direction == Direction.SE) {
            position = position.getSouthEast();
            direction = direction.getOppositeDirection();
        } else if (direction == Direction.SW) {
            position = position.getSouthWest();
            direction = direction.getOppositeDirection();
        }
        ShowRoadAction sra = getFade(ShowRoadAction.class, DEFAULT_DURATION, 1);
        sra.setPosition(position);
        sra.setDirection(direction);
        return sra;
    }
}