package cz.nic.tablexia.game.games.kidnapping.actors;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;

import cz.nic.tablexia.loader.application.ApplicationFontManager;
import cz.nic.tablexia.util.ui.TablexiaLabel;

/**
 * Created by lhoracek on 5/19/15.
 */
public class EarOverlay extends Group {

    private static final ApplicationFontManager.FontType_NEW    FONT_TYPE   = ApplicationFontManager.FontType_NEW.REGULAR_30;
    private static final Color                              FONT_COLOR  = Color.WHITE;

    private Image ear, overlay;
    private TablexiaLabel text;

    public EarOverlay(String text, Texture overlayTexture, TextureRegion earTexture) {
        this.addActor(overlay = new Image(overlayTexture));
        this.addActor(ear = new Image(earTexture));
        this.addActor(this.text = new TablexiaLabel(text, new TablexiaLabel.TablexiaLabelStyle(FONT_TYPE, FONT_COLOR)));
    }

    @Override
    protected void sizeChanged() {
        super.sizeChanged();
        overlay.setSize(getWidth(), getHeight());
        ear.setPosition(getWidth() / 2 - ear.getWidth() / 2, getHeight() / 2 - ear.getHeight() / 2);
        text.setPosition(getWidth() / 2 - text.getWidth() / 2, getHeight() / 5 - text.getHeight() / 2);
    }

    public Label getText() {
        return text;
    }
}
