package cz.nic.tablexia.game.games.kidnapping.generator;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import java.util.Set;

import cz.nic.tablexia.game.difficulty.GameDifficulty;
import cz.nic.tablexia.game.games.kidnapping.media.DirectionSounds;
import cz.nic.tablexia.game.games.kidnapping.model.Position;
import cz.nic.tablexia.game.games.kidnapping.util.DirectionsHelper;

/**
 * Created by lhoracek on 5/15/15.
 */
public class SoundPathGenerator {
    private final Random         random;
    private final GameDifficulty gameDifficulty;

    public SoundPathGenerator(Random random, GameDifficulty gameDifficulty) {
        this.random = random;
        this.gameDifficulty = gameDifficulty;
    }

    public List<DirectionSounds.SoundPack> generatePath(List<Position> path, Locale locale) {
        Set<Integer> usedSounds = new HashSet<Integer>();
        List<DirectionSounds.SoundPack> sounds = new ArrayList<DirectionSounds.SoundPack>();
        for (int i = 0; i < path.size(); i++) {
            DirectionSounds.SoundPack nextSoundPack = null;
            do {
                nextSoundPack = DirectionSounds.getRandomSoundPack(random, gameDifficulty, locale, DirectionsHelper.getLastDirectionFrom(path, i), DirectionsHelper.getNextDirection(path, i));
            } while (usedSounds.contains(nextSoundPack.getSoundNumber()));
            sounds.add(nextSoundPack);
            usedSounds.add(nextSoundPack.getSoundNumber());
        }
        return sounds;
    }
}
