package cz.nic.tablexia.game.games.kidnapping.util;

import cz.nic.tablexia.game.AbstractTablexiaGame;
import cz.nic.tablexia.game.GameDefinition;
import cz.nic.tablexia.game.games.kidnapping.Properties;
import cz.nic.tablexia.game.games.kidnapping.model.GameState;
import cz.nic.tablexia.shared.model.Game;

/**
 * Created by lhoracek on 10/6/15.
 */
public class KidnappingResultResolver implements GameDefinition.GameResultResolver {
    @Override
    public AbstractTablexiaGame.GameResult getGameCupsResult(Game game) {
        int[] levels = Properties.GAMERULE_CUPS[game.getGameDifficulty() - 1];
        if (game.getGameScoreValue(GameState.GAME_MISSES) != null) {
            int misses = Integer.valueOf(game.getGameScoreValue(GameState.GAME_MISSES));
            if (misses <= levels[0]) {
                return AbstractTablexiaGame.GameResult.THREE_STAR;
            } else if (misses <= levels[1]) {
                return AbstractTablexiaGame.GameResult.TWO_STAR;
            } else if (misses <= levels[2]) {
                return AbstractTablexiaGame.GameResult.ONE_STAR;
            }
        }
        return AbstractTablexiaGame.GameResult.NO_STAR;

    }
    @Override
    public float getGameScoreResult(Game game) {
        return Float.parseFloat(game.getGameScore(GameState.GAME_MISSES, "0"));
    }
}
