package cz.nic.tablexia.game.games.night_watch.helper;

import com.badlogic.gdx.graphics.Color;

import net.dermetfan.utils.Pair;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import cz.nic.tablexia.game.difficulty.GameDifficulty;
import cz.nic.tablexia.game.games.night_watch.assets.NightWatchAssets;

/**
 * Created by Vaclav Tarantik on 30.4.2015.
 */
public class TextureHelper {
    private static final int NUMBER_OF_BACKGROUNDS_FOR_ANIMATION = 7;
    private static final int NIGHT_TO_DAY_FIRST_TEXTURE_INDEX = 4;

    public static List<Pair<Integer,Integer>> sixteenWindowsProperties = new ArrayList<Pair<Integer,Integer>>();
    public static List<Pair<Integer,Integer>> twentyFourWindowsPositions = new ArrayList<Pair<Integer,Integer>>();
    public static List<Pair<Integer,Integer>> thirtyTwoWindowsPositions = new ArrayList<Pair<Integer,Integer>>();

    public static Map<Color,Integer> colorMap = new HashMap<Color, Integer>();

    static {
        colorMap.put(new Color (110 / 255f, 120 / 255f, 130 / 255f, 1), 0);
        colorMap.put(new Color(1, 1, 0, 1), 1);
        colorMap.put(new Color(1, 0, 0, 1), 2);
        colorMap.put(new Color(1, 0, 1, 1), 3);
        colorMap.put(new Color(0, 0, 1, 1), 4);
        colorMap.put(new Color(0, 1, 1, 1), 5);
        colorMap.put(new Color(0, 1, 0, 1), 6);
        colorMap.put(new Color(1, 1, 1, 1), 7);
        colorMap.put(new Color(1, 100 / 255f, 0, 1), 8);
        colorMap.put(new Color(1, 0, 100 / 255f, 1), 9);
        colorMap.put(new Color(1, 100 / 255f, 100 / 255f, 1), 10);
        colorMap.put(new Color(100 / 255f, 100 / 255f, 1, 1), 11);
        colorMap.put(new Color(0, 1, 100 / 255f, 1), 12);
        colorMap.put(new Color(0, 100 / 255f, 1, 1), 13);
        colorMap.put(new Color(100 / 255f, 1, 1, 1), 14);
        colorMap.put(new Color(100 / 255f, 100 / 255f, 100 / 255f, 1), 15);
        colorMap.put(new Color(200 / 255f, 100 / 255f, 1, 1), 16);
        colorMap.put(new Color(200 / 255f, 200 / 255f, 1, 1), 17);
        colorMap.put(new Color(100 / 255f, 200 / 255f, 100 / 255f, 1), 18);
        colorMap.put(new Color(200 / 255f, 1, 1, 1), 19);
        colorMap.put(new Color(200 / 255f, 200 / 255f, 200 / 255f, 1), 20);
        colorMap.put(new Color(100 / 255f, 200 / 255f, 1, 1), 21);
        colorMap.put(new Color(1, 100 / 255f, 200 / 255f, 1), 22);
        colorMap.put(new Color(1, 200 / 255f, 0, 1), 23);
        colorMap.put(new Color(150 / 255f, 1, 200 / 255f, 1), 24);
        colorMap.put(new Color(150 / 255f, 1, 100 / 255f, 1), 25);
        colorMap.put(new Color(1, 1, 100 / 255f, 1), 26);
        colorMap.put(new Color(1, 150 / 255f, 100 / 255f, 1), 27);
        colorMap.put(new Color(150 / 255f, 150 / 255f, 100 / 255f, 1), 28);
        colorMap.put(new Color(150 / 255f, 1, 150 / 255f, 1), 29);
        colorMap.put(new Color(1, 150/255f, 150 / 255f, 1), 30);
        colorMap.put(new Color(150 / 255f, 150 / 255f, 1, 1), 31);

        sixteenWindowsProperties.add(new Pair<Integer, Integer>(32, 2));//0
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(64, 282));//1
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(169, 237));//2
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(246, 201));//3
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(185, 373));//4
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(253, 324));//5
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(317, 290));//6
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(342, 409));//7
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(507, 422));//8
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(565, 436));//9
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(503, 293));//10
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(627, 391));//11
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(634, 291));//12
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(701, 377));//13
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(733, 222));//14
        sixteenWindowsProperties.add(new Pair<Integer, Integer>(792, 223));//15

        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(17, 134));//0
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(134, 148));//1
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(89, 378));//2
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(492, 391));//3
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(221, 88));//4
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(257, 226));//5
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(374, 255));//6
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(415, 257));//7
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(375, 182));//8
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(424, 314));//9
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(530, 320));//10
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(456, 225));//11
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(533, 218));//12
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(655, 376));//13
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(677, 290));//14
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(676, 210));//15
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(718, 403));//16
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(700, 300));//17
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(732, 203));//18
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(774, 422));//19
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(797, 288));//20
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(867, 295));//21
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(790, 174));//22
        twentyFourWindowsPositions.add(new Pair<Integer,Integer>(874, 88));//23

        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(4, 258));//0
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(87, 257));//1
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(161, 257));//2
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(294, 381));//3
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(127, 393));//4
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(6, 130));//5
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(85, 141));//6
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(156, 147));//7
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(238, 222));//8
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(238, 303));//9
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(289, 301));//10
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(297, 228));//11
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(342, 295));//12
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(352, 221));//13
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(480, 309));//14
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(525, 317));//15
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(585, 325));//16
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(467, 213));//17
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(530, 227));//18
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(590, 221));//19
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(725, 370));//20
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(871, 396));//21
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(680, 268));//22
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(735, 272));//23
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(792, 272));//24
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(853, 276));//25
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(933, 275));//26
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(679, 193));//27
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(733, 196));//28
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(791, 191));//29
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(812, 124));//30
        thirtyTwoWindowsPositions.add(new Pair<Integer,Integer>(932, 173));//31

        if (sixteenWindowsProperties.size() != 16 || twentyFourWindowsPositions.size() != 24 || thirtyTwoWindowsPositions.size() != 32) {
            throw new IllegalStateException("Incomplete windows position info");
        }
    }

    public static List<String> getBackgroundTexturesNames() {
        List<String> namesToReturn = new ArrayList<String>();
        for (int i = 0; i < NUMBER_OF_BACKGROUNDS_FOR_ANIMATION; i++) {
            namesToReturn.add(NightWatchAssets.BACKGROUND_FOLDER + i);
        }
        return namesToReturn;
    }

    public static List<String> getWindowsNames(GameDifficulty gameDifficulty) {
        List<String> listToReturn = new ArrayList<String>();
        for (int i = 0; i < GameRulesHelper.getNumberOfWindowsForDifficulty(gameDifficulty); i++) {
            listToReturn.add(NightWatchAssets.WINDOWS_FOLDER + Integer.toString(i));
        }
        return listToReturn;
    }

    public static List<Pair<Integer,Integer>> getWindowsPositions(GameDifficulty gameDifficulty){
        switch (gameDifficulty) {
            case EASY:
                return sixteenWindowsProperties;
            case MEDIUM:
                return twentyFourWindowsPositions;
            case HARD:
                return thirtyTwoWindowsPositions;
            default:
                throw new IllegalStateException("Illegal difficulty parameter value!");
        }
    }

    public static List<String> getDaytimeTransitionTextureNames(boolean dayToNight) {
        int startingIndex = 0;
        int endingIndex = 0;
        if (dayToNight) {
            startingIndex = 1;
            endingIndex = NIGHT_TO_DAY_FIRST_TEXTURE_INDEX;
        } else {
            startingIndex = NIGHT_TO_DAY_FIRST_TEXTURE_INDEX;
            endingIndex = NUMBER_OF_BACKGROUNDS_FOR_ANIMATION;
        }
        List<String> namesToReturn = new ArrayList<String>();
        for (int i = startingIndex; i < endingIndex; i++) {
            namesToReturn.add(NightWatchAssets.BACKGROUND_FOLDER + i);
        }
        //adding initial bg if night to day
        if (!dayToNight) {
            namesToReturn.add(NightWatchAssets.BACKGROUND_FOLDER + 0);
        }
        return namesToReturn;
    }
}
