package cz.nic.tablexia.game.games.night_watch.solution;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import cz.nic.tablexia.game.difficulty.GameDifficulty;
import cz.nic.tablexia.game.games.night_watch.helper.GameRulesHelper;

/**
 * Created by Václav Tarantík on 13.5.15.
 */
public class GameSolutionGenerator {

   public static Map<Integer,List<Solution>> generateSolutions(GameDifficulty gameDifficulty,Random random) {
        Map<Integer,List<Solution>> mapToReturn = new HashMap<Integer, List<Solution>>();

       int numberOfLevels =  GameRulesHelper.getNumberOfLevelsPerGame();
        for (int i = 0; i < numberOfLevels; i++) {
            int numberOfRoundsInCurrentLevel = GameRulesHelper.getRoundsPerLevelCount(gameDifficulty,i);

            List<Solution> currentLevelSolutions = new ArrayList<Solution>();
            for (int j = 0; j < numberOfRoundsInCurrentLevel; j++) {
                int totalWindows = GameRulesHelper.getNumberOfWindowsForDifficulty(gameDifficulty);
                int lightenedWindows = GameRulesHelper.getNumberOfWindowsLightenedInCurrentRound(gameDifficulty, i);

                Solution currentRoundSolution = new Solution(PropertiesGenerator.getRandomWindowSequence(totalWindows, lightenedWindows, random), PropertiesGenerator.getRandomTime(random));
                currentLevelSolutions.add(currentRoundSolution);
            }
            mapToReturn.put(i, currentLevelSolutions);
        }
        return mapToReturn;
    }
}
