package cz.nic.tablexia.game.games.night_watch.solution;

import java.util.List;

/**
 * Created by Václav Tarantík on 13.5.15.
 */
public class Solution {
    private List<Integer> windowSequence;
    private int time;

    public Solution(List<Integer> windowSequence,int time) {
        this.windowSequence = windowSequence;
        this.time = time;
    }

    public List<Integer> getWindowSequence() {
        return windowSequence;
    }

    public int getTime() {
        return time;
    }

    //returns whether passed parameters fulfill this solution
    public boolean check(List<Integer>chosenWindows,int chosenTime) {
        return checkTime(chosenTime) && checkWindows(chosenWindows);
    }


    public boolean checkWindows(List<Integer>chosenWindows) {
        for (int correctWindow: windowSequence) {
            if (!chosenWindows.contains(correctWindow)) {
                return false;
            }
        }
        return true;
    }

    public boolean checkTime(int chosenTime) {
        if (chosenTime != time) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "WINDOW SEQUENCE: " + windowSequence.toArray().toString() + ", TIME: " + time;
    }
}
