package cz.nic.tablexia.game.games.pursuit.action;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;

import cz.nic.tablexia.util.Point;
import cz.nic.tablexia.game.games.pursuit.model.PuzzlePiece;
import cz.nic.tablexia.util.listener.DragAndRotateActorListener;

/**
 * Created by Václav Tarantík on 3.8.15.
 */
public class MovePieceToPosition extends SequenceAction implements Interruptable {

    /*
    *Moves specified piece in position using built-in actions
     */
    public MovePieceToPosition(final PuzzlePiece draggedPiece, Point dest){
        setActor(draggedPiece);
        setTarget(draggedPiece);
        addAction(new MyMoveToAction(dest.x, dest.y, DragAndRotateActorListener.MOVETO_ANIMATION_DURATION));
    }

    public MovePieceToPosition(final PuzzlePiece draggedPiece, Point dest,Action finalAction){
        this(draggedPiece,dest);
        addAction(finalAction);
    }

    @Override
    public void interrupt() {
        for(Action action: getActions()){
            if(action instanceof Interruptable){
                ((Interruptable)action).interrupt();
            }
        }
    }
}
