package cz.nic.tablexia.game.games.pursuit.action;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;
import com.badlogic.gdx.scenes.scene2d.actions.TemporalAction;

import cz.nic.tablexia.util.Log;
import cz.nic.tablexia.util.Point;
import cz.nic.tablexia.game.games.pursuit.model.PuzzlePiece;
import cz.nic.tablexia.util.listener.DragAndRotateActorListener;

/**
 * Created by Václav Tarantík on 3.8.15.
 */
public class RotateAndMovePieceInPosition extends SequenceAction implements Interruptable{
    public RotateAndMovePieceInPosition(PuzzlePiece draggedPiece,float originalRotation, Point position, final DragAndRotateActorListener.IOnRotationFinished iOnRotationFinished){
        setActor(draggedPiece);
        setTarget(draggedPiece);
        Action rotationFinishedAction = new Action() {
            @Override
            public boolean act(float delta) {
                iOnRotationFinished.onDragAndRotationFinished();
                return true;
            }
        };

        addAction(Actions.parallel(new RotatePieceToClosestAngle(draggedPiece,originalRotation),new MovePieceToPosition(draggedPiece,position)));
        addAction(rotationFinishedAction);
    }

    public void interrupt(){
        for(Action a: getActions()){
            if(a instanceof Interruptable){
                ((Interruptable)a).interrupt();
            }
        }
    }
}
