package cz.nic.tablexia.game.games.pursuit.action;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;

import cz.nic.tablexia.game.games.pursuit.helper.ArithmeticsHelper;
import cz.nic.tablexia.game.games.pursuit.model.PuzzlePiece;
import cz.nic.tablexia.util.listener.DragAndRotateActorListener;

/**
 * Created by Václav Tarantík on 3.8.15.
 */
public class RotatePieceToClosestAngle extends SequenceAction {
    public RotatePieceToClosestAngle(PuzzlePiece draggedPiece){
        setTarget(draggedPiece);
        setActor(draggedPiece);
        addAction(Actions.rotateTo(ArithmeticsHelper.getClosestRightAngle(draggedPiece.getRotation()), DragAndRotateActorListener.ROTATION_ANIMATION_DURATION));
    }
    public RotatePieceToClosestAngle(PuzzlePiece draggedPiece,float originalRotation){
        setTarget(draggedPiece);
        setActor(draggedPiece);
        addAction(Actions.rotateTo(ArithmeticsHelper.getAngleInRotationDirection(originalRotation,draggedPiece.getRotation()), DragAndRotateActorListener.ROTATION_ANIMATION_DURATION));
    }

    public RotatePieceToClosestAngle(PuzzlePiece draggedPiece, float originalRotation,final DragAndRotateActorListener.IOnRotationFinished iOnRotationFinished){
        this(draggedPiece,originalRotation);
        Action afterAction = new Action() {
            @Override
            public boolean act(float delta) {
                iOnRotationFinished.onDragAndRotationFinished();
                return true;
            }
        };
        addAction(afterAction);
    }
}
