package cz.nic.tablexia.game.games.pursuit.action;

import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;

import cz.nic.tablexia.util.Point;
import cz.nic.tablexia.game.games.pursuit.model.PuzzlePiece;

/**
 * Created by Václav Tarantík on 3.8.15.
 */
public class SwitchPiecesAction extends SequenceAction {
    public SwitchPiecesAction(final PuzzlePiece draggedPiece, Point draggedPieceRelativePosition, final PuzzlePiece overlappedPiece, Point overlappedPieceRelativePosition, Action onSwitchFinishedAction){
        addAction(Actions.parallel(new MovePieceToPosition(draggedPiece, overlappedPieceRelativePosition),
                new MovePieceToPosition(overlappedPiece, draggedPieceRelativePosition)));
        addAction(onSwitchFinishedAction);

        int overlappedPieceActualPosition = overlappedPiece.getActualPosition();
        int draggedPieceActualPosition = draggedPiece.getActualPosition();

        draggedPiece.setActualPosition(overlappedPieceActualPosition);
        overlappedPiece.setActualPosition(draggedPieceActualPosition);
    }
}
