package cz.nic.tablexia.game.games.pursuit.action;

import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Path;
import com.badlogic.gdx.math.Vector2;

import cz.nic.tablexia.util.actions.MoveAlongAction;

/**
 * Created by Vitaliy Vashchenko on 24.6.16.
 */
public class VehicleMoveAction extends MoveAlongAction {

    private float parentSize;
    private Path<Vector2> path;
    private float duration;
    private Music[] vehicleMusic;
    private int soundIndex;
    public VehicleMoveAction(Path<Vector2> path, float duration, float parentSize, Music[] vehicleMusic) {
        super(path, duration);
        setRotate(true);
        this.path = path;
        this.duration = duration;
        this.parentSize = parentSize;
        this.vehicleMusic = vehicleMusic;
        soundIndex = MathUtils.random(0,vehicleMusic.length-1);
    }


    @Override
    protected void update(float percent) {
        Vector2 value = new Vector2();

        path.valueAt(value, percent);

        actor.setPosition(parentSize*value.x-actor.getWidth()/2,parentSize*value.y - actor.getHeight()/2);
        actor.setRotation(path.derivativeAt(value, percent).angle() - 90);
        
    }


    @Override
    protected void begin() {
        vehicleMusic[soundIndex].setVolume(1);
        vehicleMusic[soundIndex].setLooping(true);
        vehicleMusic[soundIndex].play();
        super.begin();
    }

    @Override
    protected void end() {
        vehicleMusic[soundIndex].stop();
        super.end();
    }

}
