package cz.nic.tablexia.game.games.pursuit.helper;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import cz.nic.tablexia.game.games.pursuit.assets.PursuitAssets;
import cz.nic.tablexia.game.games.pursuit.model.Maps;
import cz.nic.tablexia.game.games.pursuit.model.VehicleType;
import cz.nic.tablexia.util.Point;

/**
 * Created by Václav Tarantík on 18.6.15.
 */
public class TextureHelper {

    private static final Maps   maps [] = Maps.values();
    public static final Point   FLAG_BLACK_DOT_RELATIVE_POSITION = new Point(0.295f,0.129f);
    public static final Point   FINISH_FLAG_SIZE = new Point(75, 60);
    private static final String PNG_SUFFIX = ".png";
    private static final String RED_MAP_NAME = "red";

    public static String getBgTexturePath() {
        return PursuitAssets.BACKGROUND;
    }

    public static List<String> getMapsNames() {
        List<String> listToReturn = new ArrayList<String>();
        for (int i = 1; i < 5; i++) {
            listToReturn.add(PursuitAssets.MAPS_DIR + "map" + Integer.toString(i));
        }
        return listToReturn;
    }

    public static String getMapFullName(int mapNumber) {
        return getMapRegionName(mapNumber) + PNG_SUFFIX;
    }

    public static String getClickMapPath(int mapNumber) {
        return getMapRegionName(mapNumber) + RED_MAP_NAME + PNG_SUFFIX;
    }

    private static String getMapRegionName(int mapNumber) {
        return PursuitAssets.MAPS_DIR + maps[mapNumber].getTextureRegionName();
    }

    public static VehicleType getVehicleTextureName(Random random,int mapNumber) {
        if (maps[mapNumber].getTextureRegionName().equals("map2") || maps[mapNumber].getTextureRegionName().equals("map13")) {
            return   VehicleType.BOAT;
        } else if (maps[mapNumber].getTextureRegionName().equals("map7")) {
            return  VehicleType.TRAIN;
        }
         return  random.nextBoolean() ? VehicleType.CAR : VehicleType.MOTORCYCLE;

    }

    public static String getFinishFlagTextureName(){
        return PursuitAssets.FINISH_FLAG;
    }

    public static Point getVehicleStartPosition(float parentGroupWidth,int mapNumber){
        Point relativeStartPositon = maps[mapNumber].getStartPointCoords();
        return new Point(parentGroupWidth*relativeStartPositon.x,parentGroupWidth*relativeStartPositon.y);
    }

    public static Point getFinishFlagPosition(float parentGroupWidth,int mapNumber){
        Point relativeFinishPosition = maps[mapNumber].getEndPointCoords();
        return new Point(parentGroupWidth*relativeFinishPosition.x,parentGroupWidth*relativeFinishPosition.y);
    }

}
