package cz.nic.tablexia.game.games.pursuit.model;

import cz.nic.tablexia.game.games.pursuit.helper.PositionHelper;
import cz.nic.tablexia.util.Point;

/**
 * Created by Václav Tarantík on 10.8.15.
 */
public enum Maps {
    // TODO add car initial rotation
    MAP1("map1", new Point(0.866f, 0.1f), new Point(0.26f, 0.85f), PositionHelper.PursuitPositionDefinition.MAP_1),
    MAP2("map2", new Point(0.64f, 0.11f), new Point(0.22f, 0.75f), PositionHelper.PursuitPositionDefinition.MAP_2),
    MAP3("map3", new Point(0.08f, 0.41f), new Point(0.79f, 0.71f), PositionHelper.PursuitPositionDefinition.MAP_3),
    MAP4("map4", new Point(0.95f, 0.33f), new Point(0.18f, 0.57f), PositionHelper.PursuitPositionDefinition.MAP_4),
    MAP5("map5", new Point(0.94f, 0.12f), new Point(0.86f, 0.82f), PositionHelper.PursuitPositionDefinition.MAP_5),
    MAP6("map6", new Point(0.95f, 0.17f), new Point(0.45f, 0.32f), PositionHelper.PursuitPositionDefinition.MAP_6),
    MAP7("map7", new Point(0.56f, 0.07f), new Point(0.36f, 0.83f), PositionHelper.PursuitPositionDefinition.MAP_7),
    MAP8("map8", new Point(0.16f, 0.19f), new Point(0.83f, 0.79f), PositionHelper.PursuitPositionDefinition.MAP_8),
    MAP9("map9", new Point(0.15f, 0.11f), new Point(0.81f, 0.83f), PositionHelper.PursuitPositionDefinition.MAP_9),
    MAP10("map10", new Point(0.22f, 0.07f), new Point(0.76f, 0.84f),PositionHelper.PursuitPositionDefinition.MAP_10),
    MAP11("map11", new Point(0.61f, 0.11f), new Point(0.21f, 0.69f),PositionHelper.PursuitPositionDefinition.MAP_11),
    MAP12("map12", new Point(0.89f, 0.17f), new Point(0.2f, 0.85f),PositionHelper.PursuitPositionDefinition.MAP_12),
    MAP13("map13", new Point(0.08f, 0.06f), new Point(0.88f, 0.73f),PositionHelper.PursuitPositionDefinition.MAP_13),
    MAP14("map14", new Point(0.18f, 0.08f), new Point(0.32f, 0.84f),PositionHelper.PursuitPositionDefinition.MAP_14);

    private String textureRegionName;
    //relatives position of checkpoints on map
    private Point startPointCoords;
    private Point endPointCoords;
    
    private PositionHelper.PursuitPositionDefinition pursuitPositionDefinition;

    Maps(String textureRegionName, Point startPointCoords, Point endPointCoords, PositionHelper.PursuitPositionDefinition positionDefinition){
        this.textureRegionName = textureRegionName;
        this.startPointCoords = startPointCoords;
        this.endPointCoords = endPointCoords;
        this.pursuitPositionDefinition = positionDefinition;
    }

    public String getTextureRegionName(){
        return textureRegionName;
    }

    public cz.nic.tablexia.util.Point getStartPointCoords(){
        return startPointCoords;
    }

    public cz.nic.tablexia.util.Point getEndPointCoords(){
        return endPointCoords;
    }

    public PositionHelper.PursuitPositionDefinition getPursuitPositionDefinition() {
        return pursuitPositionDefinition;
    }
}
