package cz.nic.tablexia.game.games.pursuit.model;

import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

/**
 * Created by Václav Tarantík on 17.6.15.
 */
public class PuzzlePiece extends RotatedAndDraggedImage {
    private int id;
    private boolean dragged;
    private int correctPosition;
    private int actualPosition;

    public PuzzlePiece(final int id, TextureRegion texture) {
        super(texture);
        setOrigin(getWidth() / 2, getHeight() / 2);
        this.id = id;
        setTouchable(Touchable.disabled);

    }

    public int getId() {
        return id;
    }

    @Override
    public String toString() {
        return "Piece[id: " + id + "]";
    }

    public int getCorrectPosition() {
        return correctPosition;
    }

    public void setCorrectPosition(int correctPosition) {
        this.correctPosition = correctPosition;
    }

    public int getActualPosition() {
        return actualPosition;
    }

    public void setActualPosition(int actualPosition) {
        this.actualPosition = actualPosition;
    }
}
