package cz.nic.tablexia.game.games.shooting_range.actors;

import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import cz.nic.tablexia.game.common.media.GfxLibrary;
import cz.nic.tablexia.game.games.shooting_range.media.TextureType;

/**
 * Created by lhoracek on 6/23/15.
 */
public class Carousel extends Group {
    private Image      carouselBase;
    private Image      flower;// TODO change type to Flower
    private GfxLibrary gfxLibrary;

    public Carousel(GfxLibrary gfxLibrary) {
        addActor(carouselBase = new Image(gfxLibrary.getTextureRegion(TextureType.CAROUSEL)));
        setSize(carouselBase.getWidth(), carouselBase.getHeight());
        setTouchable(Touchable.disabled);
        setSize(carouselBase.getWidth(), carouselBase.getHeight());
        setOrigin(getWidth() / 2, getHeight() / 2);
        this.gfxLibrary = gfxLibrary;
    }

    public void showNextFlower(final TextureType textureType) { // TODO change type to Flower
        final Image oldFlower = this.flower;
        this.flower = new Image(gfxLibrary.getTextureRegion(textureType));
        addActor(flower);
        flower.setOrigin(getWidth() / 10 * 3, getHeight() / 10 * 4);
        flower.setX(getWidth() / 10 * 2);
        flower.setY(getHeight() / 10);
        flower.setRotation(-getRotation() + 90);
        addAction(Actions.sequence(Actions.rotateBy(-90, 0.5f, Interpolation.elasticOut), (oldFlower == null ? Actions.delay(0) : Actions.removeActor(oldFlower))));
    }
}
