package cz.nic.tablexia.game.games.shooting_range.actors;

import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import cz.nic.tablexia.game.games.shooting_range.model.Wave;

/**
 * Created by lhoracek on 6/23/15.
 */
public class Effect extends Group {
    private Image effectImage;
    private Wave  wave;

    protected Effect() {
        setTouchable(Touchable.disabled);
    }

    public Effect(TextureRegion texture, float x, float y) {
        setTouchable(Touchable.disabled);
        addActor(effectImage = new Image(texture));
        effectImage.setOrigin(effectImage.getWidth() / 2, effectImage.getHeight() / 2);
        setPosition(x, y);
        init();
    }

    protected void init() {
        effectImage.addAction(Actions.parallel(Actions.scaleTo(0.5f, 0.5f, 0.3f), Actions.moveBy(0, 100, 0.3f), Actions.alpha(0.3f, 0.3f)));
        addAction(Actions.sequence(Actions.delay(0.3f), Actions.removeActor()));
    }
}
