package cz.nic.tablexia.game.games.shooting_range.actors;

import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import cz.nic.tablexia.game.common.media.GfxLibrary;
import cz.nic.tablexia.game.games.shooting_range.media.TextureType;

/**
 * Created by lhoracek on 6/23/15.
 */
public class Smoke extends Effect {

    private static final TextureType[] textures = new TextureType[]{TextureType.BOX_SMOKE_1, TextureType.BOX_SMOKE_2, TextureType.BOX_SMOKE_3, TextureType.BOX_SMOKE_4, TextureType.BOX_SMOKE_5};

    public Smoke(GfxLibrary gfxLibrary, float x, float y) {
        init();
        for (int i = 0; i < textures.length; i++) {
            Image image = new Image(gfxLibrary.getTextureRegion(textures[i]));
            setSize(Math.max(getWidth(), image.getWidth()), Math.max(getHeight(), image.getHeight()));
            addActor(image);
            image.setVisible(false);
            image.addAction(Actions.sequence(Actions.delay(0.6f * i), Actions.visible(true), Actions.alpha(0), Actions.fadeIn(0.2f), Actions.delay(0.3f), Actions.fadeOut(0.2f)));
        }
        addAction(Actions.sequence(Actions.delay(5), Actions.removeActor()));
        setPosition(x - getWidth() / 2, y);
    }

    @Override
    protected void init() {
        // nothing
    }
}
