package cz.nic.tablexia.game.games.shooting_range.actors;

import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import cz.nic.tablexia.game.common.media.GfxLibrary;
import cz.nic.tablexia.game.games.shooting_range.media.TextureType;

/**
 * Created by lhoracek on 6/23/15.
 */
public class Watch extends Group {
    private Image watch, watchHand;

    public Watch(GfxLibrary gfxLibrary) {
        addActor(watch = new Image(gfxLibrary.getTextureRegion(TextureType.WATCH)));
        addActor(watchHand = new Image(gfxLibrary.getTextureRegion(TextureType.WATCH_HAND)));
        watchHand.setPosition(254, 166);
        watchHand.setOrigin(watchHand.getWidth() / 2, 15);
        setTouchable(Touchable.disabled);
    }

    public void setTime(int time) {
        int newRotation = (time % 60) * -6;
        watchHand.addAction(Actions.rotateTo(newRotation, Math.abs(watch.getRotation() - newRotation) * 0.002f, Interpolation.elasticOut));
    }

	public float getWatchHeight() {
		return watch.getHeight();
	}
}
