package cz.nic.tablexia.game.games.shooting_range.media;

import java.util.Arrays;
import java.util.List;

import cz.nic.tablexia.game.common.media.AssetDescription;
import cz.nic.tablexia.game.difficulty.GameDifficulty;

/**
 * Created by lhoracek on 6/22/15.
 */
public enum TextureType implements AssetDescription {

    WATCH("watch"), //
    WATCH_HAND("watch_hand"), //

    CAROUSEL("carousel"), //

    BACKGROUND("background"), //
    FRAME("frame"), //

    BOX_BAD("box_bad"), //
    BOX_GOOD("box_good"), //

    WAVE_1("plan2"), //
    WAVE_2("plan1"), //
    WAVE_3("plan3"), //

    FLOWER_1("flowers/1"), //
    FLOWER_2("flowers/2"), //
    FLOWER_3("flowers/3"), //
    FLOWER_4("flowers/4"), //
    FLOWER_5("flowers/5"), //
    FLOWER_6("flowers/6"), //
    FLOWER_7("flowers/7"), //
    FLOWER_8("flowers/8"), //
    FLOWER_9("flowers/9"), //
    FLOWER_10("flowers/10"), //
    FLOWER_11("flowers/11"), //
    FLOWER_12("flowers/12"), //
    FLOWER_13("flowers/13"), //
    FLOWER_14("flowers/14"), //
    FLOWER_15("flowers/15"), //
    FLOWER_16("flowers/16"), //
    FLOWER_17("flowers/17"), //
    FLOWER_18("flowers/18"), //
    FLOWER_19("flowers/19"), //
    FLOWER_20("flowers/20"), //
    FLOWER_21("flowers/21"), //
    FLOWER_22("flowers/22"), //
    FLOWER_23("flowers/23"), //
    FLOWER_24("flowers/24"), //

    BOX_SMOKE_1("effects/1smoke"), //
    BOX_SMOKE_2("effects/2smoke"), //
    BOX_SMOKE_3("effects/3smoke"), //
    BOX_SMOKE_4("effects/4smoke"), //
    BOX_SMOKE_5("effects/5smoke"), //
    BOX_HIT("effects/good_plus1"), //
    BOX_TIME_MINUS_7("effects/bad_minus7"), //
    BOX_TIME_MINUS_5("effects/bad_minus5"), //
    BOX_TIME_PLUS_5("effects/good_plus5"), //
    BOX_TIME_PLUS_7("effects/good_plus7"), //
    BOX_SPEED_UP("effects/bad_fast"), //
    BOX_SPEED_DOWN("effects/good_slow"), //

    ; //

    public static final TextureType[] BOXES                = {BOX_BAD, BOX_GOOD};
    public static final TextureType[] EFFECTS              = {BOX_SMOKE_1, BOX_SMOKE_2, BOX_SMOKE_3, BOX_SMOKE_4, BOX_SMOKE_5, BOX_TIME_MINUS_5, BOX_TIME_MINUS_7, BOX_TIME_PLUS_5, BOX_TIME_PLUS_7, BOX_SPEED_UP, BOX_SPEED_DOWN};
    public static final TextureType[] FLOWERS_LEVEL_EASY   = {FLOWER_1, FLOWER_6, FLOWER_9, FLOWER_13, FLOWER_17, FLOWER_21};
    public static final TextureType[] FLOWERS_LEVEL_MEDIUM = {FLOWER_2, FLOWER_4, FLOWER_5, FLOWER_7, FLOWER_11, FLOWER_12, FLOWER_14, FLOWER_15, FLOWER_17, FLOWER_19, FLOWER_21, FLOWER_22};
    public static final TextureType[] FLOWERS_LEVEL_HARD   = {FLOWER_1, FLOWER_2, FLOWER_3, FLOWER_4, FLOWER_5, FLOWER_6, FLOWER_7, FLOWER_8, FLOWER_9, FLOWER_10, FLOWER_11, FLOWER_12, FLOWER_13, FLOWER_14, FLOWER_15, FLOWER_16, FLOWER_17, FLOWER_18, FLOWER_19, FLOWER_20, FLOWER_21, FLOWER_22, FLOWER_23, FLOWER_24};

    private final String resource;

    private TextureType(String resource) {
        this.resource = resource;
    }

    public String getResource() {
        return resource;
    }

    public static List<TextureType> getTargetPack(GameDifficulty gameDifficulty) {
        switch (gameDifficulty) {
            case EASY:
                return Arrays.asList(TextureType.FLOWERS_LEVEL_EASY);
            case MEDIUM:
                return Arrays.asList(TextureType.FLOWERS_LEVEL_MEDIUM);
            case HARD:
                return Arrays.asList(TextureType.FLOWERS_LEVEL_HARD);
            default:
                throw new IllegalStateException("Unknown difficulty");
        }
    }
}