package cz.nic.tablexia.game.games.shooting_range.model;

import cz.nic.tablexia.game.games.shooting_range.Properties;
import cz.nic.tablexia.game.games.shooting_range.media.TextureType;

/**
 * Created by lhoracek on 6/22/15.
 */
public class GameState {

    private boolean running = false;

    private int   score        = 0;
    private int   hits         = 0;
    private int   misses       = 0;
    private int   wrongTargets = 0;
    private int   boxesBadHit  = 0;
    private int   boxesGoodHit = 0;
    private float time         = 0f;
    private TextureType currentTarget;
    private int   hitLimit  = 0;
    private float gameSpeed = Properties.GAME_SPEED_NORMAL;

    public int getHitLimit() {
        return hitLimit;
    }

    public void setGameSpeed(float gameSpeed) {
        this.gameSpeed = gameSpeed;
    }

    public void setHitLimit(int limit) {
        this.hitLimit = limit;
    }

    public int getScore() {
        return score;
    }

    public void addScore(int diff) {
        score += diff;
    }

    public void addMiss() {
        misses++;
        addScore(-1);
    }

    public void addWrongTarget() {
        wrongTargets++;
        addScore(-1);
    }

    public void addBoxGood() {
        boxesGoodHit++;
    }

    public void addBoxBad() {
        boxesBadHit++;
    }

    public int getHits() {
        return hits;
    }

    public void addHit() {
        this.hits++;
        addScore(2);
        hitLimit--;
    }

    public int getMisses() {
        return misses;
    }

    public int getWrongTargets() {
        return wrongTargets;
    }

    public int getBoxesBadHit() {
        return boxesBadHit;
    }

    public int getBoxesGoodHit() {
        return boxesGoodHit;
    }

    public float getTime() {
        return time;
    }

    public float getGameSpeed() {
        return gameSpeed;
    }

    public void addTime(float delta) {
        time = Math.max(0, Math.min(Properties.GAME_TIME, time + (delta * gameSpeed)));
    }

    public boolean isRunning() {
        return running;
    }

    public void setRunning(boolean running) {
        this.running = running;
    }

    public TextureType getCurrentTarget() {
        return currentTarget;
    }

    public void setCurrentTarget(TextureType currentTarget) {
        this.currentTarget = currentTarget;
    }
}
