package cz.nic.tablexia.game.games.shooting_range.tools;

import cz.nic.tablexia.game.AbstractTablexiaGame;
import cz.nic.tablexia.game.GameDefinition;
import cz.nic.tablexia.game.games.shooting_range.Properties;
import cz.nic.tablexia.shared.model.Game;

/**
 * Created by lhoracek on 10/6/15.
 */
public class ShootingRangeResultResolver implements GameDefinition.GameResultResolver {
    @Override
    public AbstractTablexiaGame.GameResult getGameCupsResult(Game game) {
        int[][] CUPS = {Properties.CUPS_EASY, Properties.CUPS_MEDIUM, Properties.CUPS_HARD};
        int gameScore = Integer.valueOf(game.getGameScore(Properties.SCORE_TOTAL, "0"));
        int gameDificultyOrdinal = game.getGameDifficulty() - 1;

        if (gameScore > CUPS[gameDificultyOrdinal][2]) {
            return AbstractTablexiaGame.GameResult.THREE_STAR;
        } else if (gameScore > CUPS[gameDificultyOrdinal][1]) {
            return AbstractTablexiaGame.GameResult.TWO_STAR;
        } else if (gameScore > CUPS[gameDificultyOrdinal][0]) {
            return AbstractTablexiaGame.GameResult.ONE_STAR;
        }
        return AbstractTablexiaGame.GameResult.NO_STAR;
    }

    @Override
    public float getGameScoreResult(Game game) {
        return Float.parseFloat(game.getGameScore(Properties.SCORE_TOTAL, "0"));
    }

}
