package cz.nic.tablexia.loader;

import com.badlogic.gdx.audio.Sound;

import cz.nic.tablexia.util.TablexiaSound;

public class TablexiaSoundManager extends TablexiaAbstractFileManager {

    public TablexiaSoundManager() {
        super(AssetsStorageType.EXTERNAL);
    }

    public TablexiaSoundManager(AssetsStorageType storageType) {
        super(storageType);
    }

    public void loadSound(String soundName) {
        loadSound(soundName, true);
    }

    public void loadSound(String soundName, boolean checkSoundExistence) {
        loadAsset(soundName, Sound.class, checkSoundExistence);
    }

    public Sound getSound(String soundName) {
        Sound sound = getAsset(soundName, Sound.class);
        TablexiaSound tablexiaSound = new TablexiaSound(sound);
        return tablexiaSound;
    }
}
