package cz.nic.tablexia.menu.user;

import cz.nic.tablexia.loader.application.ApplicationAtlasManager;

/**
 * Created by Vitaliy Vashchenko on 8.1.16.
 */
public enum  UserAvatarDefinition {

    AVATAR_0(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_0,13),
    AVATAR_1(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_1,9),
    AVATAR_2(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_2,1),
    AVATAR_3(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_3,10),
    AVATAR_4(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_4,11),
    AVATAR_5(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_5,12),
    AVATAR_6(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_6,2),
    AVATAR_7(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_7,3),
    AVATAR_8(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_8,4),
    AVATAR_9(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_9,5),
    AVATAR_10(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_10,6),
    AVATAR_11(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_11,7),
    AVATAR_12(ApplicationAtlasManager.USERMENU_MENUITEM_AVATAR_12,8);

    private String avatarPath;
    private int order;

    UserAvatarDefinition(String avatarPath, int order) {
        this.avatarPath = avatarPath;
        this.order = order;
    }

    public String getAvatarPath() {
        return avatarPath;
    }

    public int getOrder() {
        return order;
    }

    public static String getAvatar(String id){
        return values()[Integer.parseInt(id)].getAvatarPath();
    }

    public static String getAvatar(int id){
        return values()[id].getAvatarPath();
    }

    public static int getOrdinalByOrder(int order) {
        for(UserAvatarDefinition def : values()) {
            if(def.getOrder() == order) return def.ordinal();
        }
        return 0;
    }
}
