package cz.nic.tablexia.menu.user;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.utils.Align;

import cz.nic.tablexia.loader.application.ApplicationAtlasManager;
import cz.nic.tablexia.loader.application.ApplicationFontManager;
import cz.nic.tablexia.loader.application.ApplicationTextManager;
import cz.nic.tablexia.menu.main.user.UserSelectBox;
import cz.nic.tablexia.util.ui.TablexiaLabel;

/**
 * Created by Matyáš Latner.
 */
public abstract class UserMenuNewSelectBoxItemGroup extends Actor implements UserSelectBox.UserSelectBoxItem {

    private static final ApplicationFontManager.FontType_NEW    NEWUSER_TEXT_FONT   = ApplicationFontManager.FontType_NEW.BOLD_20;
    private static final Color                              NEWUSER_TEXT_COLOR  = new Color(0.098f, 0.086f, 0.075f, 1f);
    private static final int                                NEWUSER_TEXT_ALIGN  = Align.center;

    private final NinePatch     background;
    private final String        text;

    private TablexiaLabel       textLabel;

    public UserMenuNewSelectBoxItemGroup() {
        background  = ApplicationAtlasManager.getInstance().getPatch(ApplicationAtlasManager.USERMENU_MENUBUTTON_BACKGROUND);
        text        = ApplicationTextManager.getInstance().getText(ApplicationTextManager.ApplicationTextsAssets.USERMENU_NEWUSER);
        textLabel   = new TablexiaLabel(text, new TablexiaLabel.TablexiaLabelStyle(NEWUSER_TEXT_FONT, NEWUSER_TEXT_COLOR));
        textLabel.setAlignment(NEWUSER_TEXT_ALIGN);
    }

    public abstract void performAction();

    @Override
    public void draw(Batch batch, float parentAlpha) {
        NEWUSER_TEXT_COLOR.a = parentAlpha;

        background.draw(batch, getX(), getY(), getWidth(), getHeight());

        textLabel.setBounds(getX(), getY(), getWidth(), getHeight());
        textLabel.draw(batch, parentAlpha);
    }
}
