package cz.nic.tablexia.screen.about;

import java.util.ArrayList;
import java.util.List;


public enum Links {

    NIC_CS("CZ.NIC", "https://www.nic.cz/setlang/?language=cs", LinkGroups.OTHER),
    NIC_EN("CZ.NIC", "https://www.nic.cz/setlang/?language=en", LinkGroups.OTHER),
    TABLEXIA("www.tablexia.cz", "https://www.tablexia.cz/cs/", LinkGroups.OTHER),
    TABLEXIA_SK("www.tablexia.cz", "https://www.tablexia.cz/sk/", LinkGroups.OTHER),
    TABLEXIA_DE("www.tablexia.cz", "https://www.tablexia.cz/de/", LinkGroups.OTHER),
    TABLEXIA_GIT("GitLab CZ.NIC", "https://gitlab.labs.nic.cz/labs/tablexia/tree/master", LinkGroups.OTHER),
    TABLEXIA_FACEBOOK("Tablexia Facebook", "https://www.facebook.com/tablexia", LinkGroups.SOCIAL),
    TABLEXIA_MAIL("Tablexia Mail", "mailto:info@tablexia.cz", LinkGroups.SOCIAL),
    TABLEXIA_TWITTER("Tablexia Twitter", "https://twitter.com/tablexia", LinkGroups.SOCIAL),
    LIBGDX("libGDX,", "https://libgdx.badlogicgames.com/", LinkGroups.LIBRARY),
    GRADLE_ANDROID_COMMAND("gradle-android-command-plugin,", "https://github.com/novoda/gradle-android-command-plugin", LinkGroups.LIBRARY),
    SDK_MANAGER("sdk-manager-plugin,", "https://github.com/JakeWharton/sdk-manager-plugin", LinkGroups.LIBRARY),
    GRADLE_SPOON("gradle-spoon-plugin,", "https://github.com/x2on/gradle-spoon-plugin", LinkGroups.LIBRARY),
    GWT_GRADLE("gwt-gradle-plugin,", "https://github.com/steffenschaefer/gwt-gradle-plugin", LinkGroups.LIBRARY),
    MBASSADOR("mbassador,", "https://github.com/bennidi/mbassador", LinkGroups.LIBRARY),
    JCABI_MANIFESTRS("jcabi-manifests,", "http://manifests.jcabi.com/", LinkGroups.LIBRARY),
    SQLITE("sqlite-jdbc,", "https://github.com/xerial/sqlite-jdbc", LinkGroups.LIBRARY),
    SQLDROID("sqldroid,", "https://github.com/SQLDroid/SQLDroid", LinkGroups.LIBRARY),
    FLURRY_ANALYTICS("FlurryAnalytics,", "http://www.flurry.com/", LinkGroups.LIBRARY),
    ROBOTIUM("robotium,", "https://github.com/robotiumtech/robotium", LinkGroups.LIBRARY),
    JUNIT("JUnit,", "http://junit.org/", LinkGroups.LIBRARY),
    ROBOVM("robovm,", "https://robovm.com/", LinkGroups.LIBRARY),
    LIBGDX_UTILS("libgdx-utils,", "https://bitbucket.org/dermetfan/libgdx-utils/wiki/Home", LinkGroups.LIBRARY),
    GUAVA("guava,", "https://code.google.com/p/guava-libraries/", LinkGroups.LIBRARY),
    JACKSON_CORE("fasterxml,", "http://wiki.fasterxml.com/JacksonHome", LinkGroups.LIBRARY),
    SPOON_CLIENT("spoon-client", "https://github.com/square/spoon", LinkGroups.LIBRARY);
    // TODO: 20.11.15 add fb & twitter

    private String linkName;
    private String linkAddress;
    private LinkGroups linkGroup;


    Links(String linkName, String linkAddress, LinkGroups linkGroup) {
        this.linkName = linkName;
        this.linkAddress = linkAddress;
        this.linkGroup = linkGroup;
    }

    public String getLinkAddress() {
        return linkAddress;
    }

    public String getLinkName() {
        return linkName;
    }

    public LinkGroups getLinkGroup() {
        return linkGroup;
    }

    public static List<Links> getGroupLinks(LinkGroups group) {
        List<Links> linksList = new ArrayList<Links>();
        for (Links link : Links.values()) {
            if (link.getLinkGroup() == group) {
                linksList.add(link);
            }
        }
        return linksList;
    }
}
