package cz.nic.tablexia.screen.encyclopedia.content;

import com.badlogic.gdx.utils.JsonReader;
import com.badlogic.gdx.utils.JsonValue;

import java.util.ArrayList;
import java.util.List;

import cz.nic.tablexia.screen.encyclopedia.content.model.Content;
import cz.nic.tablexia.screen.encyclopedia.content.model.ContentDefinition;

/**
 * Created by Václav Tarantík on 2.9.15.
 */
public class ContentParser {

     private static List<Content>  contentList;

    public static List<Content> parseEncyclopediaPageContent(String jsonLine) {
        contentList = new ArrayList<Content>();

        JsonReader jsonReader = new JsonReader();
        JsonValue jsonValue = jsonReader.parse(jsonLine);

        for (int i = 0; i < jsonValue.size; i++) {
            JsonValue rootObject = jsonValue.get(i);
            if (rootObject != null) {
                for (int j = 0; j < rootObject.size; j++) {
                    JsonValue componentObject = rootObject.get(j);
                    if (componentObject.name() != null && componentObject.name().length() > 0) {
                        ContentDefinition contentDefinition = ContentDefinition.getContentDefinitionForClassName(componentObject.name());
                        if (contentDefinition != null) {
                            contentList.add(contentDefinition.getNewInstance(componentObject));
                        }
                    }
                }
            }
        }

        return contentList;
    }

    public static List<Content> getContentList(){
        return contentList;
    }


}
