package cz.nic.tablexia.screen.encyclopedia.content.model;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Cell;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.utils.JsonValue;

import cz.nic.tablexia.screen.AbstractTablexiaScreen;

/**
 * Created by Václav Tarantík on 3.9.15.
 */
public abstract class Content {

    private static final int PAD_RIGHT = 20;
    private static final int PAD_BOTTOM = 10;

    abstract Actor render(AbstractTablexiaScreen screen,float parentContainerWidth);
    abstract void update(AbstractTablexiaScreen screen);

    public Cell addToCell(Table contentTable,AbstractTablexiaScreen screen, float parentContainerWidth){
        return contentTable.add(render(screen, parentContainerWidth)).expandX().fillX().padRight(PAD_RIGHT).padBottom(PAD_BOTTOM).left();
    }

    protected void checkJsonContent(JsonValue jsonValue, String contentKey) {
        if (!jsonValue.has(contentKey)) {
            throw new RuntimeException("Json \"" + contentKey + "\" key not found in " + getClass().getName());
        }
    }

    public void refreshContent(AbstractTablexiaScreen screen){
            this.update(screen);
    }
}
