package cz.nic.tablexia.screen.gamemenu;

/**
 * Created by lhoracek on 3/11/15.
 * Edited by Drahomir Karchnak
 */
public final class GameMenuAssets {
    private GameMenuAssets() {
    }

    public static final String GFX_PATH = "gfx/";
    public static final String SFX_PATH = "sfx/";

    public static final String OFFICE = GFX_PATH + "office";
    public static final String OFFICE_HALLOFFAME = GFX_PATH + "office_halloffame";
    public static final String OFFICE_CLICKMAP = GFX_PATH + "clickablemap";
    public static final String OFFICE_HELP = GFX_PATH + "helplayer";
    public static final String OVERLAY = GFX_PATH + "overlay";
    public static final String VIGNETTE = GFX_PATH + "vignetting";
    public static final String DESK = GFX_PATH + "desk";
    public static final String ENCYCLOPEDIA_PRESSED = GFX_PATH + "encyclopedia_pressed";
    public static final String HALLOFFAME_PRESSED = GFX_PATH + "halloffame_pressed";
    public static final String STATISTICS_PRESSED = GFX_PATH + "statistics_pressed";
    public static final String DOOR_PRESSED = GFX_PATH + "streetdoor_pressed";
    public static final String PROFILE_PRESSED = GFX_PATH + "profile_pressed";

    public static final String HELP_BUTTON_PRESSED = GFX_PATH + "helpbutton_pressed";
    public static final String HELP_BUTTON_RELEASE = GFX_PATH + "helpbutton_unpressed";

    public static final String DIFF_BAR = GFX_PATH + "difficultyseekbar_background";
    public static final String DIFF_THUMB = GFX_PATH + "difficultyseekbar_thumb";
    public static final String DIFF_THUMB_EASY = GFX_PATH + "difficultyseekbar_thumb_easy";
    public static final String DIFF_THUMB_HARD = GFX_PATH + "difficultyseekbar_thumb_hard";
    public static final String DIFF_THUMB_MEDIUM = GFX_PATH + "difficultyseekbar_thumb_medium";
    public static final String PROGRESSBAR_FILL = GFX_PATH + "progressbar_fill";

    public static final String BASE_ASSETS_ROBBERY = "bankovniloupez";
    public static final String BASE_ASSETS_PURSUIT = "pronasledovani";
    public static final String BASE_ASSETS_KIDNAPPING = "unos";
    public static final String BASE_ASSETS_NIGHT_WATCH = "nocnisledovani";
    public static final String BASE_ASSETS_SHOOTING_RANGE = "strelnice";
    public static final String BASE_ASSETS_IN_THE_DARKNESS = "potme";

    public static final String LEFT_OVERSCROLL  = GFX_PATH + "overscroll_left";
    public static final String RIGHT_OVERSCROLL = GFX_PATH + "overscroll_right";

    public static final String BASE_ASSETS_FOREGROUND_POSTFIX = "fore";
    public static final String BASE_ASSETS_MIDDLE_POSTFIX = "mid";
    public static final String BASE_ASSETS_BACKGROUND_POSTFIX = "back";
    public static final String BASE_ASSETS_TITLE_POSTFIX = "title";
    public static final String BASE_ASSETS_PROGRESSBAR_POSTFIX = "progressbar";
    public static final String BASE_ASSETS_START_BUTTON_RELEASED_POSTFIX = "startbutton";
    public static final String BASE_ASSETS_START_BUTTON_PRESSED_POSTFIX = "startbutton_pressed";
    public static final String BASE_ASSETS_INTRO_SOUND_POSTFIX = "intro.mp3";

    public static final String WALL_MID = GFX_PATH + "wall_mid";
    public static final String WALL_BACK = GFX_PATH + "wall_back";
	public static final String WALL_SIGN = GFX_PATH + "wall_sign";

    public static final String STEP_EASY_MEDIUM = SFX_PATH + "step_1_2.mp3";
    public static final String STEP_MEDIUM_EASY = SFX_PATH + "step_2_1.mp3";
    public static final String STEP_MEDIUM_HARD = SFX_PATH + "step_2_3.mp3";
    public static final String STEP_HARD_MEDIUM = SFX_PATH + "step_3_2.mp3";

    public static final String AMBIENT_MUSIC    = SFX_PATH + "ambient.mp3";

    /**
     * This enum represents all type of assets for GameMenuPage
     * Both graphics and sounds are included
     *
     * field folder tells you, which folder the file is in... for example "gfx/"
     * field postFix tells you whats the post fix of the file... for example "_mid"
     *
     */
    public enum AssetType {
        FORE                (GFX_PATH, BASE_ASSETS_FOREGROUND_POSTFIX),
        MID                 (GFX_PATH, BASE_ASSETS_MIDDLE_POSTFIX),
        BACK                (GFX_PATH, BASE_ASSETS_BACKGROUND_POSTFIX),
        TITLE               (GFX_PATH, BASE_ASSETS_TITLE_POSTFIX),
        PROGRESSBAR         (GFX_PATH, BASE_ASSETS_PROGRESSBAR_POSTFIX),
        STARTBUTTON         (GFX_PATH, BASE_ASSETS_START_BUTTON_RELEASED_POSTFIX),
        STARTBUTTON_PRESSED (GFX_PATH, BASE_ASSETS_START_BUTTON_PRESSED_POSTFIX),
        INTRO               (SFX_PATH, BASE_ASSETS_INTRO_SOUND_POSTFIX);

        private String folder;
        private String postFix;

        AssetType(String folder, String postFix) {
            this.folder = folder;
            this.postFix = postFix;
        }

        public String getFolder() {
            return folder;
        }

        public String getPostFix() {
            return postFix;
        }
    }
}
