package cz.nic.tablexia.screen.gamemenu.event;

import cz.nic.tablexia.bus.ApplicationBus;
import cz.nic.tablexia.game.GameDefinition;
import cz.nic.tablexia.screen.gamemenu.GameMenuScreen;

/**
 * Created by Matyáš Latner.
 */
public class ShowGameMenuPageEvent implements ApplicationBus.ApplicationEvent {

    private static final boolean DEFAULT_SMOOTH_SCROLL = true;

    private GameMenuScreen.GameMenuPageDefinition gameMenuPageDefinition;
    private boolean smoothScroll;

    public ShowGameMenuPageEvent(GameDefinition gameDefinition) {
        this(gameDefinition, DEFAULT_SMOOTH_SCROLL);
    }

    public ShowGameMenuPageEvent(GameDefinition gameDefinition, boolean smoothScroll) {
        this(GameMenuScreen.GameMenuPageDefinition.getGameMenuPageForGameDefinition(gameDefinition), smoothScroll);
    }

    public ShowGameMenuPageEvent(GameMenuScreen.GameMenuPageDefinition gameMenuPageDefinition) {
        this(gameMenuPageDefinition, DEFAULT_SMOOTH_SCROLL);
    }

    public ShowGameMenuPageEvent(GameMenuScreen.GameMenuPageDefinition gameMenuPageDefinition, boolean smoothScroll) {
        this.gameMenuPageDefinition = gameMenuPageDefinition;
        this.smoothScroll = smoothScroll;
    }

    public GameMenuScreen.GameMenuPageDefinition getGameMenuPageDefinition() {
        return gameMenuPageDefinition;
    }

    public boolean isSmoothScroll() {
        return smoothScroll;
    }
}
