package cz.nic.tablexia.sync.work;

import com.badlogic.gdx.Net;
import com.badlogic.gdx.net.HttpRequestHeader;
import com.badlogic.gdx.net.HttpStatus;

import cz.nic.tablexia.shared.model.User;
import cz.nic.tablexia.sync.RestSynchronizationService;
import cz.nic.tablexia.util.Log;

/**
 * Created by frantisek on 19.1.16.
 */
public class DeleteUser extends SyncWork {

    public DeleteUser(User user) {
        setUser(user);
    }

    @Override
    public String getUrl() {
        return RestSynchronizationService.getDeleteUserUrl(getUser().getUuid());
    }

    @Override
    public String getHttpMethod() {
        return Net.HttpMethods.DELETE;
    }

    @Override
    public void send(RestSynchronizationService sync) {
        if (getUser() == null || getUser().getUuid() == null || getUser().getUuid().isEmpty()) {
            Log.err(this.getClass(), "Can't delete user from REST server without uuid");
            return;
        }
        sync.setHeader(HttpRequestHeader.ContentType, "application/json");
        sync.send();
    }

    @Override
    protected int getExpectedSuccessResponseCode() {
        return HttpStatus.SC_OK;
    }
}
