package cz.nic.tablexia.util;

import com.badlogic.gdx.Application;
import com.badlogic.gdx.Gdx;

public class Log {
	
	public enum TablexiaLogLevel {
		
		NONE	(Application.LOG_NONE),
		DEBUG	(Application.LOG_DEBUG),
		INFO	(Application.LOG_INFO),
		ERROR	(Application.LOG_ERROR);
		
		private int logLevelValue;

		TablexiaLogLevel(int logLevelValue) {
			this.logLevelValue = logLevelValue;
		}
		
		public int getLogLevelValue() {
			return logLevelValue;
		}
	}
	
	public static void setLoglevel(TablexiaLogLevel logLevel) {
		Gdx.app.setLogLevel(logLevel.getLogLevelValue());
	}
	
	
	/////////////////// DEBUG
	
	public static void debug(Class<?> clazz, String message, Throwable exception) {
		Gdx.app.debug(clazz.getSimpleName(), message, exception);
	}
	
	public static void debug(String tag, String message, Throwable exception) {
		Gdx.app.debug(tag, message, exception);
	}
	
	public static void debug(Class<?> clazz, String message) {
		Gdx.app.debug(clazz.getSimpleName(), message);
	}
	
	public static void debug(String tag, String message) {
		Gdx.app.debug(tag, message);
	}
	
	
	
	/////////////////// INFO
	
	public static void info(Class<?> clazz, String message, Throwable exception) {
		Gdx.app.log(clazz.getSimpleName(), message, exception);
	}
	
	public static void info(String tag, String message, Throwable exception) {
		Gdx.app.log(tag, message, exception);
	}
	
	public static void info(Class<?> clazz, String message) {
		Gdx.app.log(clazz.getSimpleName(), message);
	}
	
	public static void info(String tag, String message) {
		Gdx.app.log(tag, message);
	}
	
	
	
	/////////////////// ERROR
	
	public static void err(Class<?> clazz, String message, Throwable exception) {
		Gdx.app.error(clazz.getSimpleName(), message, exception);
	}
	
	public static void err(String tag, String message, Throwable exception) {
		Gdx.app.error(tag, message, exception);
	}
	
	public static void err(Class<?> clazz, String message) {
		Gdx.app.error(clazz.getSimpleName(), message);
	}
	
	public static void err(String tag, String message) {
		Gdx.app.error(tag, message);
	}

}
