package cz.nic.tablexia.util.ui;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import cz.nic.tablexia.loader.application.ApplicationFontManager;

/**
 * Created by bcx on 2/18/16.
 */
public class TablexiaLabel extends Label {
    public static class TablexiaLabelStyle {
        private ApplicationFontManager.FontType_NEW fontType;

        //This is not just a regular color, its canadian one!
        private Color colour;

        public TablexiaLabelStyle(ApplicationFontManager.FontType_NEW fontType, Color color) {
            this.fontType = fontType;
            this.colour = color;
        }

        public ApplicationFontManager.FontType_NEW getFontType() {
            return fontType;
        }

        public Color getColor() {
            return colour;
        }
    }

    /**
     * Fields...
     */
    private TablexiaLabelStyle  tablexiaLabelStyle;
    private boolean             markupEnabled;
    private float               scale;

    public TablexiaLabel(CharSequence text, TablexiaLabelStyle style) {
        this(text, style, false);
    }

    public TablexiaLabel(CharSequence text, TablexiaLabelStyle style, boolean markupEnabled) {
        super(text, new LabelStyle(ApplicationFontManager.getInstance().getDistanceFieldFont(style.getFontType()), style.getColor()));
        this.markupEnabled = markupEnabled;
        setTablexiaLabelStyle(style);
    }

    public void setTablexiaLabelStyle(TablexiaLabelStyle style) {
        if(style != null) {
            tablexiaLabelStyle = style;
        }

        scale = tablexiaLabelStyle.getFontType().getSize() / ApplicationFontManager.DISTANCE_FIELD_FONT_SIZE;
        setFontScale(scale);

        //TODO - Should probably be "ApplicationFontManager.getInstance().getDistanceFieldFont(style.getFontType())"
        setStyle(new LabelStyle(getStyle().font, getTablexiaLabelStyle().getColor()));
    }

    public TablexiaLabelStyle getTablexiaLabelStyle() {
        return tablexiaLabelStyle;
    }

    private void beforeDraw(Batch batch) {
        batch.setShader(ApplicationFontManager.getInstance().getDistanceFieldShader());
        ApplicationFontManager.getInstance().getDistanceFieldFont(tablexiaLabelStyle.getFontType()).setDistanceFieldSmoothing((ApplicationFontManager.DISTANCE_FIELD_FONT_DEFAULT_SMOOTHING * scale));
        ApplicationFontManager.getInstance().getDistanceFieldFont(tablexiaLabelStyle.getFontType()).getData().markupEnabled = markupEnabled;
    }

    private void afterDraw(Batch batch) {
        batch.setShader(null);
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        beforeDraw(batch);
        super.draw(batch, parentAlpha);
        afterDraw(batch);
    }
}
