package cz.nic.tablexia.util.ui.button;

import cz.nic.tablexia.loader.application.ApplicationInternalTextureManager;

/**
 * Created by Matyáš Latner.
 */
public class StandardTablexiaButton extends TablexiaButton {

    private static final boolean                            DEFAULT_TEXT_WRAP           = false;

    public enum TablexiaButtonType {

        BLUE    (ApplicationInternalTextureManager.InternalNinePatch.BUTTON_BLUE_UNPRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_BLUE_PRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_BLUE_SOLARIZED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_DISABLED_PATCH),
        GREEN   (ApplicationInternalTextureManager.InternalNinePatch.BUTTON_GREEN_UNPRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_GREEN_PRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_GREEN_SOLARIZED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_DISABLED_PATCH),
        RED     (ApplicationInternalTextureManager.InternalNinePatch.BUTTON_RED_UNPRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_RED_PRESSED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_RED_SOLARIZED_PATCH,
                ApplicationInternalTextureManager.InternalNinePatch.BUTTON_DISABLED_PATCH);

        private ApplicationInternalTextureManager.InternalNinePatch unpressedPath;
        private ApplicationInternalTextureManager.InternalNinePatch pressedPath;
        private ApplicationInternalTextureManager.InternalNinePatch solarizedPath;
        private ApplicationInternalTextureManager.InternalNinePatch disabledPath;

        TablexiaButtonType(ApplicationInternalTextureManager.InternalNinePatch unpressedPath,
                           ApplicationInternalTextureManager.InternalNinePatch pressedPath,
                           ApplicationInternalTextureManager.InternalNinePatch solarizedPath,
                           ApplicationInternalTextureManager.InternalNinePatch disabledPath) {

            this.unpressedPath  = unpressedPath;
            this.pressedPath    = pressedPath;
            this.solarizedPath  = solarizedPath;
            this.disabledPath   = disabledPath;
        }

        public ApplicationInternalTextureManager.InternalNinePatch getUnpressedPath() {
            return unpressedPath;
        }

        public ApplicationInternalTextureManager.InternalNinePatch getPressedPath() {
            return pressedPath;
        }

        public ApplicationInternalTextureManager.InternalNinePatch getSolarizedPath() {
            return solarizedPath;
        }

        public ApplicationInternalTextureManager.InternalNinePatch getDisabledPath() {
            return disabledPath;
        }
    }

    public StandardTablexiaButton(String text) {
        this(text, TablexiaButtonType.GREEN);
    }

    public StandardTablexiaButton(String text, TablexiaButtonType tablexiaButtonType) {
        this(text, tablexiaButtonType, DEFAULT_TEXT_WRAP);
    }

    public StandardTablexiaButton(String text, TablexiaButtonType tablexiaButtonType, boolean wrapText) {
        super(text, wrapText,
                ApplicationInternalTextureManager.getInstance().getPatch(tablexiaButtonType.getUnpressedPath()),
                ApplicationInternalTextureManager.getInstance().getPatch(tablexiaButtonType.getPressedPath()),
                ApplicationInternalTextureManager.getInstance().getPatch(tablexiaButtonType.getSolarizedPath()),
                ApplicationInternalTextureManager.getInstance().getPatch(tablexiaButtonType.getDisabledPath()));
    }
}
