package cz.nic.tablexia.util.ui.dialog.components;

import net.engio.mbassy.listener.Handler;

import cz.nic.tablexia.TablexiaApplication;
import cz.nic.tablexia.bus.ApplicationBus;
import cz.nic.tablexia.util.ui.dialog.TablexiaComponentDialog;

/**
 * Created by frantisek on 23. 2. 2016.
 */
public class BackButtonHideComponent extends TablexiaDialogComponentAdapter {

    private boolean animated;

    public BackButtonHideComponent() {
        this(TablexiaComponentDialog.DEFAULT_HIDE_ANIMATION);
    }

    public BackButtonHideComponent(boolean animated) {
        this.animated = animated;
    }

    public void show() {
        super.show();
        ApplicationBus.getInstance().subscribe(this);
    }

    public void hide() {
        super.hide();
        ApplicationBus.getInstance().unsubscribe(this);
    }

    @Handler(priority = TablexiaApplication.BackButtonPressed.DIALOG_PRIORITY)
    public void onBackButtonPress(TablexiaApplication.BackButtonPressed event) {
		if (event.shouldProcess(TablexiaApplication.BackButtonPressed.DIALOG_PRIORITY)) {
			event.setProcessWithPriority(TablexiaApplication.BackButtonPressed.DIALOG_PRIORITY);
            hideDialog();
		}
    }

    protected void hideDialog() {
        getDialog().hide(animated);
    }
}
