package cz.nic.tablexia.util.ui.dialog.components;

import cz.nic.tablexia.util.ui.dialog.TablexiaComponentDialog;

/**
 * Created by Matyáš Latner.
 */
public class CenterPositionDialogComponent extends TablexiaDialogComponentAdapter {

    private float screenWidth;
    private float screenHeight;

	private float dialogWidth;
	private float dialogHeight;

    public CenterPositionDialogComponent() {
    }

	public void setDialog(TablexiaComponentDialog dialog) {
		super.setDialog(dialog);
		screenWidth     = getViewportWidth();
		screenHeight    = getViewportHeight();
		if (getDialog() != null) {
			dialogWidth = getDialog().getWidth();
			dialogHeight = getDialog().getHeight();
		}
	}

    @Override
    public void show() {
		// dialog size has changed due to another component -> store new size for beforeDraw method
		if (getDialog() != null && (dialogWidth != getDialog().getWidth() || dialogHeight != getDialog().getHeight())) {
			dialogWidth = getDialog().getWidth();
			dialogHeight = getDialog().getHeight();
		}
        centerDialog();
    }

    @Override
    public void beforeDraw() {
		// Call center only if dialog size changes
		if (getDialog() != null && (dialogWidth != getDialog().getWidth() || dialogHeight != getDialog().getHeight())) {
			dialogWidth = getDialog().getWidth();
			dialogHeight = getDialog().getHeight();
			centerDialog();
		}
		// Call center only if screen size changes
        if (screenWidth != getViewportWidth() || screenHeight != getViewportHeight()) {
            screenWidth = getViewportWidth();
            screenHeight = getViewportHeight();
            centerDialog();
        }
    }

    private void centerDialog() {
		getDialog().setPosition(getViewportLeftX() + (screenWidth / 2) - (getDialog().getWidth() / 2), getViewportBottomY() + (screenHeight / 2) - (getDialog().getHeight() / 2));
    }
}
