package cz.nic.tablexia.util.ui.dialog.components;

import com.badlogic.gdx.scenes.scene2d.Event;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.ui.Cell;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;

/**
 * Created by Matyáš Latner.
 */
public class CloseButtonContentDialogComponent extends SingleButtonContentDialogComponent {

    private InputListener inputListener;

    private InputListener closeListener = new ClickListener() {

        @Override
        public boolean handle(Event e) {
            boolean result = super.handle(e);
            if (inputListener != null) {
                inputListener.handle(e);
            }
            return result;
        }

        @Override
        public void clicked(InputEvent event, float x, float y) {
            super.clicked(event, x, y);
            if (getDialog() != null) {
                getDialog().hide();
            }
        }
    };

    public CloseButtonContentDialogComponent(String buttonText) {
        super(buttonText);
    }

    @Override
    public SingleButtonContentDialogComponent setInputListener(InputListener inputListener) {
        this.inputListener = inputListener;
        return this;
    }

    @Override
    public void prepareContent(Cell content) {
        super.setInputListener(closeListener);
        super.prepareContent(content);
    }
}
