package cz.nic.tablexia.util.ui.dialog.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import cz.nic.tablexia.loader.application.ApplicationAtlasManager;

/**
 * Created by Matyáš Latner.
 */
public class DimmerDialogComponent extends TablexiaDialogComponentAdapter {

    private static final Color DEFAULT_DIMMER_COLOR = Color.BLACK;
    private static final float DEFAULT_DIMMER_ALPHA = 0.7f;

    private Float alpha;
    private Color color;

    private Image   background;

    public DimmerDialogComponent() {
        this(DEFAULT_DIMMER_ALPHA);
    }

    public DimmerDialogComponent(Float alpha) {
        this(alpha, DEFAULT_DIMMER_COLOR);
    }

    public DimmerDialogComponent(Float alpha, Color color) {
        this.alpha = alpha;
        this.color = color;
    }

    @Override
    public void prepareBackground(Group backgroundLayer) {
        background = new Image(ApplicationAtlasManager.getInstance().getColorTextureRegion(new Color(color.r, color.g, color.b, alpha)));
        backgroundLayer.addActor(background);
    }

    @Override
    public void sizeChanged() {
        background.setBounds(getViewportLeftX(),
                     getViewportBottomY(),
                     getViewportWidth(),
                     getViewportHeight());
    }
}
