package cz.nic.tablexia.util.ui.dialog.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.ui.Cell;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Scaling;

import cz.nic.tablexia.loader.application.ApplicationAtlasManager;

/**
 * Created by Matyáš Latner.
 */
public class DividerContentDialogComponent extends ImageContentDialogComponent {

    private static final float  DEFAULT_PADDING     = 1 / 20f;
    private static final float  DEFAULT_CELL_HEIGHT = 1f;
    private static final Color  DEFAULT_COLOR       = Color.BLACK;

    private Float   width;
    private Float   height;

    private Color   color;

    public DividerContentDialogComponent() {
        this(DEFAULT_CELL_HEIGHT);
    }

    public DividerContentDialogComponent(Color color) {
        this(DEFAULT_CELL_HEIGHT, null, color);
    }

    public DividerContentDialogComponent(Float height) {
        this(height, null, DEFAULT_COLOR);
    }

    public DividerContentDialogComponent(Float height, Float width) {
        this(height, width, DEFAULT_COLOR);
    }

    public DividerContentDialogComponent(Float height, Float width, Color color) {
        super(new Image(ApplicationAtlasManager.getInstance().getColorTextureRegion(color)),
                Scaling.stretch,
                1f);

        this.height = height;
        this.width  = width;
    }

    @Override
    public void sizeChanged() {
        Cell<Image> imageCell = getImageCell();
        if (imageCell != null) {
            Float cellWidth = width;
            if (cellWidth == null) {
                cellWidth = getDialog().getWidth();
                cellWidth = cellWidth - cellWidth * DEFAULT_PADDING;
            }
            imageCell.width(cellWidth).height(height).colspan(imageCell.getTable().getColumns());
        }
    }
}
