package cz.nic.tablexia.util.ui.dialog.components;

import com.badlogic.gdx.scenes.scene2d.ui.Cell;

/**
 * Created by Matyáš Latner.
 */
public class FixedSpaceContentDialogComponent extends TablexiaDialogComponentAdapter {

    private static final float  DEFAULT_HEIGHT_RATIO = 1f / 40;

    private     Float           heightRatio;
    protected   Cell            cell;

    public FixedSpaceContentDialogComponent() {
        this(DEFAULT_HEIGHT_RATIO);
    }

    public FixedSpaceContentDialogComponent(Float heightRatio) {
        this.heightRatio = heightRatio;
    }

    @Override
    public void prepareContent(Cell content) {
        cell = content;
    }

    @Override
    public void sizeChanged() {
        resize();
    }

    private void resize() {
        cell.minHeight(getDialog().getHeight() * heightRatio);
    }
}
