package cz.nic.tablexia.util.ui.dialog.components;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Cell;

import cz.nic.tablexia.TablexiaSettings;
import cz.nic.tablexia.util.ui.dialog.TablexiaComponentDialog;

/**
 * Created by Matyáš Latner.
 */
public abstract class TablexiaDialogComponentAdapter {

    private TablexiaComponentDialog dialog;

    public void setDialog(TablexiaComponentDialog dialog) {
        this.dialog = dialog;
    }

    public final TablexiaComponentDialog getDialog() {
        return dialog;
    }

    protected Stage getStage() {
        return dialog == null ? null : dialog.getStage();
    }

    protected float getViewportWidth() {
        return getStage() != null ? TablexiaSettings.getViewportWidth(getStage()) : 0;
    }

    protected float getViewportHeight() {
        return getStage() != null ? TablexiaSettings.getViewportHeight(getStage()) : 0;
    }

    protected float getViewportLeftX() {
        return getStage() != null ? TablexiaSettings.getViewportLeftX(getStage()) : 0;
    }

    protected float getViewportRightX() {
        return getStage() != null ? TablexiaSettings.getViewportRightX(getStage()) : 0;
    }

    protected float getViewportBottomY() {
        return getStage() != null ? TablexiaSettings.getViewportBottomY(getStage()) : 0;
    }

    protected float getViewportTopY() {
        return getStage() != null ? TablexiaSettings.getViewportTopY(getStage()) : 0;
    }

    public void prepareBackground(Group backgroundLayer) {}
    public void prepareContent(Cell content) {}
    public void show() {}
    public void hide() {}
    public void beforeDraw() {}
    public void afterDraw() {}
    public void drawAdditions(Batch batch, float parentAlpha) {}
    public void adaptiveSizeThresholdChanged() {}
    public void dialogTouched(float x, float y) {}
    public void sizeChanged() {}

}
