package cz.nic.tablexia.util.ui.dialog.components;

import cz.nic.tablexia.util.ui.dialog.TablexiaComponentDialog;

/**
 * Created by Matyáš Latner.
 */
public class TouchCloseDialogComponent extends TablexiaDialogComponentAdapter {

    public interface TouchListener {
        /**
         * Touch listener
         * @param x posX of touch
         * @param y posY of touch
         * @return true if u want to hide the dialog, false if u dont.
         */
        boolean dialogTouched(float x, float y, TablexiaComponentDialog dialog);
    }

    private TouchListener touchListener;

    public TouchCloseDialogComponent() {
        this(null);
    }

    public TouchCloseDialogComponent(TouchListener listener) {
        this.touchListener = listener;
    }

    @Override
    public void dialogTouched(float x, float y) {
        boolean result = true;

        if(touchListener != null)
            result = touchListener.dialogTouched(x, y, getDialog());

        if(result)
            getDialog().hide();
    }
}
